unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, sqlite3conn, sqldb, db, FileUtil,
  Forms, Controls, Graphics, Dialogs, DbCtrls, DBGrids, ExtCtrls,
  StdCtrls, Buttons;

type

  { TForm1 }

  TForm1 = class(TForm)
    btnReport: TButton;
    DBNavMembers: TDBNavigator;
    dsMembers: TDataSource;
    gridMembers: TDBGrid;
    Label1: TLabel;
    SpeedButton1: TSpeedButton;
    SQLite3Connection1: TSQLite3Connection;
    queryMembers: TSQLQuery;
    SQLTransaction1: TSQLTransaction;
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure gridMembersTitleClick(Column: TColumn);
    procedure SpeedButton1Click(Sender: TObject);
  private
  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormShow(Sender: TObject);
begin
  SQLite3Connection1.Connected := False;
  queryMembers.Active := False;
  SQLTransaction1.Active := False;

  SQLite3Connection1.DatabaseName := 'guitarclub.db';
  queryMembers.Options := [sqoKeepOpenOnCommit,sqoAutoApplyUpdates,sqoAutoCommit];
  queryMembers.SQL.Text :=
    'select * from members order by upper(lastname), upper(firstname)';

  SQLite3Connection1.Open;
  SQLTransaction1.Active := True;
  queryMembers.Open;
end;

procedure TForm1.gridMembersTitleClick(Column: TColumn);
begin
  queryMembers.IndexFieldNames := Column.Field.FieldName;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  queryMembers.Refresh;
end;

procedure TForm1.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  queryMembers.Active := False;
  SQLTransaction1.Active := False;
  SQLite3Connection1.Close;
end;

end.

